
/* CSFS Client Daemon loopback NFS interface */

/* Given: Nothing
 * Modifies: idempotent
 * Effects: returns nothing
 */
void csfscd_null ();

/* Given: file handle
 * Effects: Finds the file attributes (metadata in inode)
 * Modifies: idempotent
 * Returns:
 */
void csfscd_getattr ();

/* Given: file attributes, file handle
 * Effects: sets the attributes of the file
 * Modifies:
 * Returns: The new file attributes
 */
void csfscd_setattr

/* Given: file handle of a directory, and a file name (not a path)
 * Effects: Lookups a file handle for the file name within the directory
 * Modifies:
 * Returns: the new file handle
 */
void csfscd_lookup (dirfh, filename);

/* Given: a file handle
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_readlink

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_read

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_write

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_create

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_remove

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_rename

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_link

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_symlink

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_mkdir

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_rmdir

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_readdir

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
void csfscd_statfs

% Client daemon user agent interface


/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */

% Client daemon to server daemon interface


/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */


% User agent to client daemon interface

/* Given:
 * Effects:
 * Modifies:
 * Returns:
 */
csfsua_cache_check ();

/* Given: A path to a file
 * Effects: Places file contents
 * Modifies:
 * Returns: 0 if successful, -1 otherwise
 */
csfsua_cache_get ();

/* Given: Pathname of plaintext cache directory, cache size in 8KB blocks
 * Effects: Initializes a plaintext cache on the device specified
 * Modifies: 
 * Returns: 0 if successful, -1 otherwise
 */
int csfsua_cache_init (char *cachedir, unsigned int cachesize);

